#include "usgard.h"

score    =$80df         ; the score!
x        =$80e1         ; x pos
l        =$80e2
r        =$80e3
v        =$80E4
ll       =$80e5
rl       =$80f5
rptr     =$8105         ; random number seed
temp     =$8110


.org     0
.db      "High : "
digits:  .db      "0000"
         .db      " by "
name:    .db      "PATRICK D",0          ; zero terminated title
         .db      0


         ld       a,4
         out      (5),a         ; graphics mode

         ld       (iy+13),0     

         ld       hl,&random
         call     LD_HL_MHL
         ld       (rptr),hl     ; stuff for random #'s


         call     CLEARLCD
         ld       hl,$0007
         ld       ($800c),hl
         ld       hl,&message
         call     D_ZT_STR      ; display co-byline


         ld       ix,$80df      ; initialize variables
         ld       (ix+2),64
         ld       (ix+3),32
         ld       (ix+4),96
         ld       (ix+5),0
         ld       (ix+41),48

         ld       hl,$80e5
         ld       a,32
         ld       b,16
lleft:   ld       (hl),a
         inc      hl
         djnz     lleft
         ld       a,96
         ld       b,16
lright:  ld       (hl),a
         inc      hl
         djnz     lright
         ld       hl,0
         ld       ($8333),hl
         ld       hl,&author_msg
         call     D_ZM_STR
loop:    ld       bc,1800
wait:    dec      bc
         ld       a,b
         or       c
         jr       nz,wait
         ld       c,25
         ld       a,(ix+2)
         ld       b,a
         call     &ptoff
         dec      b
         call     &ptoff
         inc      b
         inc      b
         call     &ptoff
         dec      b
         inc      c
         call     &ptoff
         dec      c
         dec      c
         call     &ptoff
         ld       de,$fc70
         ld       hl,$fc80
         ld       bc,768
         ldir
         ld       hl,880+$fc00
         ld       b,16
         ld       a,0
lclr:    ld       (hl),a
         inc      hl
         djnz     lclr
         ld       a,(ix+3)
         add      a,(ix+5)
         ld       (ix+3),a
         ld       b,a
         ld       c,8
         call     &pton
         ld       a,(ix+4)
         add      a,(ix+5)
         ld       (ix+4),a
         ld       b,a
         ld       c,8
         call     &pton
         ld       a,%01111110
         out      (1),a
         in       a,(1)
         bit      1,a
         jr       nz,no_left
         dec      (ix+2)
no_left: bit      2,a
         jr       nz,no_right
         inc      (ix+2)
no_right:ld       a,(ix+2)
         ld       b,a
         ld       c,25
         call     &pton
         dec      b
         call     &pton
         inc      b
         inc      b
         call     &pton
         dec      b
         inc      c
         call     &pton
         dec      c
         dec      c
         call     &pton
         ld       hl,$1007
         ld       ($800c),hl
         ld       hl,(score)
         inc      hl
         ld       (score),hl
         call     D_HL_DECI
         ld       a,%00111111
         out      (1),a
         in       a,(1)
         bit      6,a
         ret      z
         ld       hl,(rptr)
         inc      hl
         res      7,h
         ld       (rptr),hl
         ld       a,(hl)
         cp       8
         jr       NC,nocc
         ld       hl,&dirs
         and      7
         ld       e,a
         ld       d,0
         ADD      hl,de
         ld       a,(hl)
         ld       (ix+5),a
nocc:    ld       a,(ix+3)
         cp       10
         jr       nz,noleftb
         ld       (ix+5),1
noleftb: ld       a,(ix+4)
         cp       116
         jr       nz,norightb
         ld       (ix+5),-1
norightb:ld       a,(ix+6)
         sub      (ix+2)
         bit      7,a
         jr       z,lose
         ld       a,(ix+2)
         sub      (ix+22)
         bit      7,a
         jr       z,lose
         ld       hl,$80e6
         ld       de,$80e5
         ld       bc,32
         ldir
         ld       a,(ix+3)
         ld       (ix+21),a
         ld       a,(ix+4)
         ld       (ix+37),a
         ld       hl,(score)
         ld       a,63
         and      l
         jp       nz,&loop
         inc      (ix+3)
         dec      (ix+4)
         jp       &loop
lose:
         ld       hl,&random
         ld       a,(ix+38)
         ld       (hl),a
         ld       a,(ix+39)
         inc      hl
         ld       (hl),a
         ld       a,1
         ld       (USG_BITS),a
         ld       hl,&best
         call     LD_HL_MHL
         ld       de,(score)
         call     CP_HL_DE
         jr       c,hisc
         ld       hl,0
         ld       ($800c),hl
         ld       hl,&lose_
         CALL     D_ZT_STR
lwk:     call     GET_KEY
         cp       9
         jr       nz,lwk
         ret
hisc:
         ld       hl,&best
         ld       de,(score)
         ld       (hl),e
         inc      hl
         ld       (hl),d
         ld       de,&digits+3
         ld       hl,(score)
         ld       b,4
p_l:     call     UNPACK_HL
         add      a,'0'
         ld       (de),a
         dec      de
         djnz     p_l
         ld       hl,0
         ld       ($800c),hl
         ld       hl, &hi_msg
         call     D_ZT_STR
         ld       hl,$b00
         ld       ($800c),hl
         ld       hl, &name
         ld       (temp),hl
         ld       b,9
space_loop:
         ld       (hl), ' '
         inc      hl
         djnz     space_loop
         ld       ix,(temp)
         ld       b,0
enter_name_loop:
         call     GET_KEY
         cp       0
         jr       z,enter_name_loop
         cp       32
         jr       z,backup
         cp       9
         jr       z,nomore
         ld       c,a
         ld       a,9
         cp       b
         jr       z,enter_name_loop
         ld       hl,&chartable
         ld       e,c
         ld       d,0
         add      hl,de
         ld       a,(hl)
         cp       0
         jr       z,enter_name_loop
         ld       (ix),a
         call     TX_CHARPUT
         inc      b
         inc      ix
         jr       enter_name_loop
backup:  dec      b
         ld       a,255
         cp       b
         jr       z,too_far
         dec      ix
         ld       (ix),' '
         ld       hl,$800d
         dec      (hl)
         ld       a,'_'
         call     TX_CHARPUT
         dec      (hl)
         jr       enter_name_loop
too_far: inc      b
         jr       enter_name_loop
nomore:  ret
hi_msg:  .db      "Highscore! _________ ",0
lose_:   .db      "LOSER!!!  Press ENTER",0
message: .db      "Z-Kart 4  Score:     "
         .db      0
ptoff:   call     FIND_PIXEL        ;Get the pixel offset
         ld       de,$FC00
         add      hl,de             ;Point into graphics memory   
         cpl                        ;Invert the accumulator
         and      (hl)              ;A now contains the modified screen byte
         ld       (hl),a            ;Write back to screen to update
         ret
pton:    call     FIND_PIXEL        ;Get the pixel offset
         ld       de,$FC00
         add      hl,de             ;Point into the graphics memory
         or       (HL)              ;A now contains the modified screen byte
         ld       (HL),A            ;Write back to screen to update
         ret
dirs:    .db      -1,1,-1,1,-1,1,0,0
random:  .dw      0
chartable:
         .db      0,0,0,0,0,0,0,0,0,0,"XTOJE",0
         .db      0," WSNID!",0,"ZVRMHC?"
         .db      0,"YUQLGB#x~+PKFA|"
         .db      "@54321.~+"
best:    .dw      0
author_msg:
         .db      "By Patrick Davidson "
         .db      "& Jim Reardon",0

.end
